Draft OrthoArray

From FreeCAD Documentation
Jump to navigation Jump to search
Other languages:
Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎português do Brasil • ‎русский
Arrow-left.svg Previous: Draft Clone.svg Clone
Next: PolarArray Draft PolarArray.svg Arrow-right.svg

Draft OrthoArray.svg Draft OrthoArray

Menu location
Modification → Array tools → Array
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
0.19
See also
Draft PolarArray, Draft CircularArray, Draft PathArray, Draft PathLinkArray, Draft PointArray, Draft PointLinkArray

Description

The Draft OrthoArray.svg Draft OrthoArray command creates an orthogonal (3-axes) array from a selected object. The command can optionally create a Link array, which is more efficient than a regular array.

The command can be used on 2D objects created with the Draft Workbench or Sketcher Workbench, but also on many 3D objects such as those created with the Part Workbench, PartDesign Workbench or Arch Workbench.

Draft Array example.png

Draft OrthoArray

Usage

  1. Optionally select one object.
  2. There are several ways to invoke the command:
    • Press the Draft OrthoArray.svg Draft OrthoArray button.
    • Select the Modification → Array tools → Draft OrthoArray.svg Array option from the menu.
  3. The Orthogonal array task panel opens. See Options for more information.
  4. If you have not yet selected an object: select one object.
  5. Enter the required parameters in the task panel.
  6. To finish the command do one of the following:
    • Click in the 3D view.
    • Press Enter.
    • Press the OK button.

Options

  • Enter the Number of elements for the X, Y and Z directions. This number must be at least 1 for every direction.
  • Enter the X intervals to specify the displacement for the elements in the X direction. For a rectangular array the Y and Z values must be 0.
  • Enter the Y intervals to specify the displacement for the elements in the Y direction. For a rectangular array the X and Z values must be 0.
  • Enter the Z intervals to specify the displacement for the elements in the Z direction. For a rectangular array the X and Y values must be 0.
  • Press the Reset X, Y or Z button to reset the displacement in the given direction to the default values.
  • If the Fuse checkbox is checked overlapping elements in the array are fused. This does not work for Link arrays.
  • If the Link array checkbox is checked a Link array instead of a regular array is created. A Link array is more efficient because its elements are App Link objects.
  • Press Esc or the Cancel button to abort the command.

Notes

  • A Draft OrthoArray can be turned into a Draft PolarArray or a Draft CircularArray by changing its DataArray Type property.
  • A Link array cannot be turned into a regular array or vice versa. The type of array must be decided at creation time.

Preferences

See also: Preferences Editor and Draft Preferences.

  • To change the number of decimals used for the input of coordinates: Edit → Preferences... → General → Units → Units settings → Number of decimals.

Properties

See also: Property editor.

The Draft OrthoArray command, the Draft PolarArray command and the Draft CircularArray command create the same object. This object is derived from a Part Feature object and inherits all its properties (with the exception of some View properties that are not inherited by Link arrays). The following properties are additional unless otherwise stated:

Data

Link

The properties in this group are only available for Link arrays. See Std LinkMake for more information.

  • DataScale (Float)
  • Data (Hidden)Scale Vector (Vector)
  • DataScale List (VectorList)
  • Data (Hidden)Visibility List (BoolList)
  • Data (Hidden)Placement List (PlacementList)
  • Data (Hidden)Element List (LinkList)
  • Data (Hidden)_ Link Touched (Bool)
  • Data (Hidden)_ Child Cache (LinkList)
  • Data (Hidden)Colored Elements (LinkSubHidden)
  • DataLink Transform (Bool)

Circular array

The properties in this group are hidden for orthogonal arrays and polar arrays.

  • DataNumber Circles (Integer): specifies the number of circular layers. Must be at least 2.
  • DataRadial Distance (Distance): specifies the distance between circular layers.
  • DataSymmetry (Integer): specifies the number of symmetry lines. This number changes the distribution of the elements in the array.
  • DataTangential Distance (Distance): specifies the distance between elements in the same circular layer. Must be larger than zero.

Objects

  • DataArray Type (Enumeration): specifies the type of array, which can be ortho, polar or circular.
  • DataAxis Reference (LinkGlobal): specifies the object and edge to be used instead of the DataAxis and DataCenter properties. Not used for orthogonal arrays.
  • DataBase (Link): specifies the object to duplicate in the array.
  • DataCount (Integer): (read-only) specifies the total number of elements in the array. Only available for Link arrays.
  • DataExpand Array (Bool): specifies whether to expand the array in the Tree view to enable the selection of its individual elements. Only available for Link arrays.
  • DataFuse (Bool): specifies if overlapping elements in the array are fused or not. Not used for Link arrays.

Orthogonal array

The properties in this group are hidden for circular arrays and polar arrays.

  • DataInterval X (VectorDistance): specifies the interval between elements in the X direction.
  • DataInterval Y (VectorDistance): specifies the interval between elements in the Y direction.
  • DataInterval Z (VectorDistance): specifies the interval between elements in the Z direction.
  • DataNumber X (Integer): specifies the number of elements in the X direction. Must be at least 1.
  • DataNumber Y (Integer): specifies the number of elements in the Y direction. Must be at least 1.
  • DataNumber Z (Integer): specifies the number of elements in the Z direction. Must be at least 1.

Polar array

The properties in this group are hidden for circular arrays and orthogonal arrays.

  • DataAngle (Angle): specifies the aperture of the circular arc. Use 360° for a full circle.
  • DataInterval Axis (VectorDistance): specifies the interval between elements in the DataAxis direction.
  • DataNumber Polar (Integer): specifies the number of elements in the polar direction.

Polar/circular array

The properties in this group are hidden for orthogonal arrays.

  • DataAxis (Vector): specifies the direction of the axis of the array.
  • DataCenter (VectorDistance): specifies the center point of the array. The axis of the array passes through this point. For circular arrays it is an offset from the DataPlacement of the DataBase object.

View

Link

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • ViewDraw Style (Enumeration)
  • ViewLine Width (FloatConstraint)
  • ViewOverride Material (Bool)
  • ViewPoint Size (FloatConstraint)
  • ViewSelectable (Bool): this is an inherited property that appears in the Selection group for other arrays
  • ViewShape Material (Material)

Base

The properties in this group, with the exception of the inherited property, are only available for Link arrays. See Std LinkMake for more information.

  • View (Hidden)Child View Provider (PersistentObject)
  • View (Hidden)Material List (MaterialList)
  • View (Hidden)Override Color List (ColorList)
  • View (Hidden)Override Material List (BoolList)
  • View (Hidden)Proxy (PythonObject): this is an inherited property.

Display Options

The properties in this group are inherited properties. See Part Feature for more information.

  • ViewBounding Box (Bool): this property is not inherited by Link arrays.
  • ViewDisplay Mode (Enumeration): for Link arrays it can be Link or ChildView. For other arrays it can be: Flat Lines, Shaded, Wireframe or Points
  • ViewShow In Tree (Bool)
  • ViewVisibility (Bool)

Draft

  • ViewPattern (Enumeration): not used.
  • ViewPattern Size (Float): not used.

Object style

The properties in this group are not inherited by Link arrays.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

Parametric array

To create a parametric orthogonal array use the make_array method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeArray method. The make_array method can create Draft OrthoArrays, Draft PolarArrays and Draft CircularArrays. For each array type one or more wrappers are available.

The main method:

array = make_array(base_object, arg1, arg2, arg3, arg4=None, arg5=None, arg6=None, use_link=True)

The wrappers for orthogonal arrays are:

array = make_ortho_array(base_object,
                         v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0), v_z=App.Vector(0, 0, 10),
                         n_x=2, n_y=2, n_z=1,
                         use_link=True)
array = make_ortho_array2d(base_object,
                           v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0),
                           n_x=2, n_y=2,
                           use_link=True)

The wrappers for rectangular arrays are:

array = make_rect_array(base_object,
                        d_x=10, d_y=10, d_z=10,
                        n_x=2, n_y=2, n_z=1,
                        use_link=True)
array = make_rect_array2d(base_object,
                          d_x=10, d_y=10,
                          n_x=2, n_y=2,
                          use_link=True)
  • base_object is the object to be arrayed. It can also be the Label (string) of an object in the current document.
  • v_x, v_y, and v_z are the vectors between the base points of the elements in the respective directions.
  • d_x, d_y, and d_z are the distances between the base points of the elements in the respective directions.
  • n_x, n_y, and n_z are the numbers of elements in the respective directions.
  • If use_link is True the created elements are App Links instead of regular copies.
  • array is returned with the created array object.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.make_ortho_array2d(rect, v_x, v_y, 3, 4)
doc.recompute()

Non-parametric array

To create a non-parametric orthogonal array use the array method of the Draft module. This method returns None.

array(objectslist, xvector, yvector, xnum, ynum)
array(objectslist, xvector, yvector, zvector, xnum, ynum, znum)

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

Draft.array(rect, v_x, v_y, 3, 4)
doc.recompute()


Arrow-left.svg Previous: Draft Clone.svg Clone
Next: PolarArray Draft PolarArray.svg Arrow-right.svg